/***************************************************************************
 *   Copyright (C) 2004 by Christoph Freundl                               *
 *   Christoph.Freundl@informatik.uni-erlangen.de                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SDLWIDGETS_BORDERWIDGET_H
#define SDLWIDGETS_BORDERWIDGET_H

#include "widget.h"

namespace SDLwidgets {

class BorderWidget : public WidgetDecorator {
public:
	BorderWidget( Widget* widget );
	virtual void draw( SDL_Surface* surface );
	virtual void setWidth( const Uint16 width );
	virtual void setMinWidth( const Uint16 min_width );
	virtual void setHeight( const Uint16 height );
	virtual void doLayout();
	virtual void layoutContent();
};

class Border3DWidget : public WidgetDecorator {
private:
	SDL_Color _shaded_color;
public:
	Border3DWidget( Widget* widget );
	virtual void draw( SDL_Surface* surface );
	virtual void setWidth( const Uint16 width );
	virtual void setMinWidth( const Uint16 min_width );
	virtual void setHeight( const Uint16 height );
	virtual void doLayout();
};

}

#endif // SDLWIDGETS_BORDERWIDGET_H
