/* $Id: bonushealth.hpp,v 1.6 2005/10/05 14:46:44 chfreund Exp $ */

#ifndef  _BONUSHEALTH_HPP_
#define  _BONUSHEALTH_HPP_

/**********************************************************/

#include  "bonus.hpp"

/**********************************************************/

//! bonus, carrying additional health
class BonusHealth : public Bonus
{
	public:

		BonusHealth( World* wp );
		~BonusHealth();

		//! reimplemented from base class Object
		Sint32 getID() const { return BONUS_HEALTH; }
		//! reimplemented from base class Bonus
		bool isWeapon() const { return false; }

		//! \name functions for the interaction with avatars
		//@{
		//! health boni can only be picked up, if the avatar needs them
		bool canBePickedUpByAvatar( const Avatar* const avatar );
		//! applies the bonus to the passed avatar
		void apply( Avatar *const avatar );
		//!
		bool mustBePutIntoPack() const { return false; }
		//@}

		//! \name (de)serialization
		//@{
		virtual Uint32 getSerializeBufferSize() const;
		virtual void serialize( Uint8*& bufferPointer ) const;
		virtual void deserialize( Uint8*& bufferPointer );
		//@}

	protected:

		Sint32 m_healingImpact;
};

/**********************************************************/

#endif // _BONUSHEALTH_HPP_
