/* $Id: counter.cpp,v 1.1 2005/10/20 19:46:52 chfreund Exp $ */

#include "counter.hpp"
#include "serialize.hpp"

Uint32 Counter::getSerializeBufferSize() const {
	return Serialize<real>::sizeOf();
}

void Counter::serialize( Uint8*& bufferPointer ) const {
	Serialize<real>::serialize( m_timeToLive, bufferPointer );
}

void Counter::deserialize( Uint8*& bufferPointer ) {
	Serialize<real>::deserialize( bufferPointer, m_timeToLive );
}

Uint32 SignalCounter::getSerializeBufferSize() const {
	return Counter::getSerializeBufferSize()
	       + 2 * Serialize<real>::sizeOf()
	       + Serialize<bool>::sizeOf();
}

void SignalCounter::serialize( Uint8*& bufferPointer ) const {
	Counter::serialize( bufferPointer );
	Serialize<real>::serialize( m_timeToSignal, bufferPointer );
	Serialize<real>::serialize( m_signalCounter, bufferPointer );
	Serialize<bool>::serialize( m_signal, bufferPointer );
}

void SignalCounter::deserialize( Uint8*& bufferPointer ) {
	Counter::deserialize( bufferPointer );
	Serialize<real>::deserialize( bufferPointer, m_timeToSignal );
	Serialize<real>::deserialize( bufferPointer, m_signalCounter );
	Serialize<bool>::deserialize( bufferPointer, m_signal );
}
