/* $Id: splashscreen.hpp,v 1.4 2005/06/28 13:55:24 chfreund Exp $ */

#ifndef _SPLASHSCREEN_HPP_
#define _SPLASHSCREEN_HPP_

#include <SDL.h>
#include <widget.h>

using namespace SDLwidgets;

class SplashScreen : public WidgetLeaf {
	private:
		SDL_Surface* m_logo;
		Uint32 m_alpha;
		SDL_TimerID m_timer;
		Uint32 m_startTicks;
		
	public:
		SplashScreen();
		~SplashScreen();
		void startAnimation();
		virtual int getWidth() const { return m_logo->w; }
		virtual int getHeight() const { return m_logo->h; }
		virtual void draw( SDL_Surface* surface );
		
	private:
		void update();
		
	friend Uint32 splashScreenUpdateWrapper( Uint32 interval, void* data );
};

Uint32 splashScreenUpdateWrapper( Uint32 interval, void* data );

#endif // _SPLASHSCREEN_HPP_
