/* $Id: wopwindow.hpp,v 1.6 2005/11/30 21:36:06 chfreund Exp $ */

#ifndef _WOPWINDOW_HPP_
#define _WOPWINDOW_HPP_

#include <string>

#include "widget.h"
#include "borderwidget.h"
#include "backgroundwidget.h"
#include "textlabel.h"
#include "image.h"
using namespace SDLwidgets;

class WopWindow : public WidgetProxy {
protected:
	static const Uint32 m_FRAME_WIDTH = 2;
	static const Uint32 m_TITLE_OFFSET = 10;
	static const Uint32 m_PADDING = 1;

	Border3DWidget* m_border;
	BackgroundWidget* m_background;
	WidgetComposite* m_content;
	SDL_Color m_titleColor;
	SDL_Color m_titleBackgroundColor;
	Uint8 m_titleAlpha;
	SDL_Color m_contentBackgroundColor;
	Uint8 m_contentAlpha;
	TextLabel m_titleLabel;
	// Image* m_rule;
	BackgroundWidget* m_rule;
	Widget* m_widget;
	
public:
	WopWindow();
	WopWindow( Widget* widget, std::string title );
	~WopWindow();
	void setWidget( Widget* widget );
	void setTitle( std::string title );
	void setContentBackgroundColor( const SDL_Color color ) {
		m_contentBackgroundColor = color;
	}
};

#endif // _WOPWINDOW_HPP_
